
// This is an ugly little utility by Matthew Suffidy to drive vjoy with 
// raw gameport binary sampling to use Microsoft SideWinder joysticks 
// in modern times. This is revision no 1 which sweeps for cpus in 
// repressed or faster clock rates than expected, getting digital
// 1 bit mode almost instantly.

#include "stdafx.h"
#include <stdio.h>
#include <stdlib.h>
#include <Windows.h>
#include <chrono>
#include <thread>
/* #include "include\inpout32.h" */
#include "include\public.h"
#include "include\vjoyinterface.h"

short gp_addr;
int gp_data[500];
char gp_extract_data[500];
bool samples_good;
unsigned int joystickid;
const UINT VJDINTERFACE = 1;

#include "joyfeeder.cpp"

typedef short (__stdcall *inpfuncPtr) (short portaddr);
typedef void (__stdcall *oupfuncPtr) (short portaddr, short datum);
inpfuncPtr inp32;
oupfuncPtr oup32;

int sample_gp()
{
    short data;
    int sample_no;
 
    oup32(gp_addr,255); 
    for (sample_no = 0; sample_no <= 499; sample_no++) 
    { 
     data = inp32(gp_addr);
     gp_data[sample_no] = data;
    }
    return 0;
} 

int dump_gp()
{
    int sample_no;

    for (sample_no = 0; sample_no <= 499; sample_no++)
    {
     putchar(gp_data[sample_no]);
    }
    return 0;
}

int extract_gp()
{
    int byte_counter;
    bool last_state;
    bool this_state;
    int sample_counter;

    last_state = 1;
    byte_counter = 0;
     for (sample_counter = 0; sample_counter <= 499; sample_counter++)
     {
      if ((gp_data[sample_counter] & 16) == 16)
       this_state = 1;
      else
       this_state = 0;
      if (this_state != last_state)
      {
       if (last_state == 0)
        last_state = 1;
       else
        last_state = 0;
       if (this_state == 1)
       { 
        gp_extract_data[byte_counter] = gp_data[sample_counter];
        byte_counter++;
       }
      }
     }
     if (byte_counter == 49)
      samples_good = 1;
     else
      samples_good = 0;
     return(0);
}

int dump_extract_gp()
{
    int byte_counter;

    for (byte_counter = 0; byte_counter <= 49; byte_counter++)
    {
     putchar(gp_extract_data[byte_counter]);
    }
    return(0);
}

int sw_init_digital(int cpu_speed_slew)
{
    int seq[] = { 80, 800, 380, 0 };
    int i;

    i = 0;
    do 
    {
     oup32(gp_addr,255);                          
     /* Trigger */
     do { } while ((inp32(gp_addr) & 1) == 1);
     /* Wait for axis to fall back to 0 */
     std::this_thread::sleep_for(std::chrono::nanoseconds(seq[i] + cpu_speed_slew));
     /* Delay magic time */
    } while (seq[++i]);
    oup32(gp_addr,255);                                     
    /* Last trigger */
    return (0);
}

int main()
{
    HINSTANCE hLib;
    bool cows_come_home;
    TCHAR txtfile_stringw[500];
    char portaddrfile[13]="portaddr.txt";
    char txtfile_string[500];
    long txtfile_data;
    FILE *portfile;
    int count;
    int count2;
    int cpu_speed_slew;

    hLib = LoadLibrary(TEXT("inpout32.dll"));
    if (hLib == NULL) 
    {
     printf("LoadLibrary Failed.\n");
     Sleep(4000);
     exit (0);
    }
    /* get the address of the function */
    inp32 = (inpfuncPtr) GetProcAddress(hLib, "Inp32");
    if (inp32 == NULL) 
    {
     printf("GetProcAddress for Inp32 Failed.\n");
     Sleep(4000);
     exit (0);
    }
    oup32 = (oupfuncPtr) GetProcAddress(hLib, "Out32");
    if (oup32 == NULL) 
    {
     printf("GetProcAddress for Oup32 Failed.\n");
     Sleep(4000);
     exit (0);
    }
  
    /* This part is about reading the file portaddr in the 
    same as the startup direcory and saving the value into
    gp_addr */

    GetModuleFileName(NULL, txtfile_stringw, 500);
    wcstombs(txtfile_string,txtfile_stringw, 500);
    count=strlen(txtfile_string)-1;
    while(txtfile_string[count]!='\\')
    {
     count--; 
    }
    for (count2 = 1; count2 <= 13; count2 ++)
    { 
     txtfile_string[count+count2]=portaddrfile[count2-1];
    }
    printf("Using port file: %s\n", txtfile_string);

    if((portfile = fopen(txtfile_string, "r" )) == NULL ) 
    {
     printf("Could not open port file.\n");
     Sleep(4000);
     exit (0);
    }
    if (fscanf(portfile, "%ld", &txtfile_data) == NULL )
    { 
     printf("Failed to extract Port Address Value. \n");
     Sleep(4000);
     exit (0);
    }
    fclose(portfile);
    printf("Using port address (decimal): %ld\n", txtfile_data);
    gp_addr = txtfile_data;

    /* End file read part*/

    cows_come_home = 0;
    printf ("Attempting to set digital 1 bit mode. \n");

    cpu_speed_slew = -200;
	
    do 
    {
     sw_init_digital(cpu_speed_slew);
     std::this_thread::sleep_for(std::chrono::nanoseconds(50));
     sw_init_digital(cpu_speed_slew);
     sample_gp();
     extract_gp();
     std::this_thread::sleep_for(std::chrono::nanoseconds(340));
     cpu_speed_slew = cpu_speed_slew + 20;
     if (cpu_speed_slew >= 200) cpu_speed_slew = -200;
    } while (samples_good!=1);
    printf ("Acquired digital 1 bit mode. \n");
    Sleep(200); 
    RelinquishVJD(VJDINTERFACE);
    // Check for vJoy
    if (!vJoyEnabled())
    {
     printf("VJoy is not enabled.\n");
     Sleep(4000);
     exit(0);
    }
    // Try to acquire vJoy
    if (!AcquireVJD(VJDINTERFACE))
    {
     printf ("Failed to acquire vjoy interface.\n");
     Sleep(4000);
     exit(0);
    }
    ResetAll();
    do 
    {
     Sleep(10);
     do 
     {
      sample_gp();    
      extract_gp();
     } while (samples_good != 1);
     feed_joy();
    } while (cows_come_home == 0);
    return 0;
}
    
